    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ----------------------
    028     * AbstractXYDataset.java
    029     * ----------------------
    030     * (C) Copyright 2004-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited).
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 05-May-2004 : Version 1 (DG);
    038     * 15-Jul-2004 : Switched getX() with getXValue() and getY() with
    039     *               getYValue() (DG);
    040     * 18-Aug-2004 : Moved from org.jfree.data --> org.jfree.data.xy (DG);
    041     *
    042     */
    043
    044    package org.jfree.data.xy;
    045
    046    import org.jfree.data.DomainOrder;
    047    import org.jfree.data.general.AbstractSeriesDataset;
    048
    049    /**
    050     * An base class that you can use to create new implementations of the
    051     * {@link XYDataset} interface.
    052     */
    053    public abstract class AbstractXYDataset extends AbstractSeriesDataset
    054            implements XYDataset {
    055
    056        /**
    057         * Returns the order of the domain (X) values.
    058         *
    059         * @return The domain order.
    060         */
    061        public DomainOrder getDomainOrder() {
    062            return DomainOrder.NONE;
    063        }
    064
    065        /**
    066         * Returns the x-value (as a double primitive) for an item within a series.
    067         *
    068         * @param series  the series index (zero-based).
    069         * @param item  the item index (zero-based).
    070         *
    071         * @return The value.
    072         */
    073        public double getXValue(int series, int item) {
    074            double result = Double.NaN;
    075            Number x = getX(series, item);
    076            if (x != null) {
    077                result = x.doubleValue();
    078            }
    079            return result;
    080        }
    081
    082        /**
    083         * Returns the y-value (as a double primitive) for an item within a series.
    084         *
    085         * @param series  the series index (zero-based).
    086         * @param item  the item index (zero-based).
    087         *
    088         * @return The value.
    089         */
    090        public double getYValue(int series, int item) {
    091            double result = Double.NaN;
    092            Number y = getY(series, item);
    093            if (y != null) {
    094                result = y.doubleValue();
    095            }
    096            return result;
    097        }
    098
    099    }